
if(!dojo._hasResource["ibm.widget.ErrorDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
	dojo._hasResource["ibm.widget.ErrorDialog"] = true;
}	

dojo.provide("ibm.widget.ErrorDialog");

dojo.require("ibm.widget._ErrorBase");

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");

dojo.declare("ibm.widget.ErrorDialog",
	[dijit.Dialog, ibm.widget._ErrorBase],
{
	widgetsInTemplate: true,
	
	templateString: dojo.cache("dijit", "../../edojo/ibm/widget/resources/ErrorDialogTemplate.html"),
	
	eid: '',
	
	stack: '',
	
	url: 'http://www.ibm.com/developerworks/views/rss/customrssatom.jsp?zone_type=AllZones&content_type=AllTypes&search_by=${query}&day=1&month=01&year=2008&max_entries=100&feed_by=rss&ibm-submit=Submit',
	
	maxResults: 5,
	
	showAbstracts: true,
	
	_items:'',
	
	actionLabel:'',
	actionFunction: function(){},

	postCreate: function(){
		dojo.style(this.domNode, {
			display: "none",
			position:"absolute"
		});
		dojo.body().appendChild(this.domNode);

		this.inherited(arguments);

		this.connect(this, "onExecute", function(){this.destroy();});
		this.connect(this, "onCancel", function(){this.destroy();});
//		this.connect(this, 'onClose', );
		this._modalconnects = [];
		
		if (this.searchCriteria==null)
			this.searchCriteria = this.eid;
		
		this._build();
	},
	
	_build: function(){
		
		
		var me = this;
		
		
		this.loadFeed(
			function(data){
				me._items = data.items;
				if (me._items.length>0)
				{
					me._writeFeed();
					me.feedDiv.style.display='block';
					me.loader.style.display='none';
				}			
			},
			function(data){
				me.loader.style.display='none';
			},
			function(data){
				alert("Error: "+data.message);
			},
			this.searchCriteria,
			this.url
		);
		
		if (this.stack!=''){
			this.stackPayload.innerHTML = this.stack;
			this.stackDiv.style.display="block";
		}
		this._addHelp();
		this._addAction();
	},
	
	
	_writeFeed: function(){
		var url = this.url.replace(/\$\{query\}/g,this.searchCriteria);
    	url = url.replace(/ /g,"%20");

		var parent = this.feedDiv;
				
		var webfeedListDiv = this.feedPayload;
		
		var ul = document.createElement("ul");
		
		var itemDisplayLimit = (this._items.length >= this.maxResults) ? this.maxResults : this._items.length;   //Limit item display list to $MaxFeedResults items
		
		for (var i=0;i<itemDisplayLimit;i++)
		{
			var li  = document.createElement("li");
			
		    var a = document.createElement("a");
			a.style.textDecoration= 'none';
		   	a.setAttribute('target','_blank');
		   	a.setAttribute('href',this._items[i].link);
		   	
			var title = document.createTextNode(this._items[i].title);
			a.appendChild(title);	
		    li.appendChild(a);
		    
			if (this.showAbstracts && this._items[i].description!=null)
			{
				var abstractDiv = document.createElement("div");
				abstractDiv.setAttribute("class","utErrorDialogFeedAbstract");
				abstractDiv.appendChild(document.createTextNode(this._items[i].description));
				li.appendChild(abstractDiv);
			}			
				
			ul.appendChild(li);
		}
		
		var webfeedSubscribe = document.createElement("p");
		webfeedSubscribe.setAttribute("class","utErrorDialogFeedSubscribe");
	
		var aSubscribe = document.createElement("a");
		aSubscribe.setAttribute("target","_blank");	 
		aSubscribe.setAttribute("href",url);
		aSubscribe.appendChild(document.createTextNode("XML"));
					   
		webfeedSubscribe.appendChild(aSubscribe);
	   
		webfeedListDiv.appendChild(ul);
		webfeedListDiv.appendChild(webfeedSubscribe);
		parent.appendChild(webfeedListDiv);
	},
	
	
	_addHelp: function(){
		if (this.helpHref!='' && this.helpHref!=null)
		{
			this.help.style.display="block";
			this.helpLink.innerHTML = "Related Help Topic - "+this.helpTitle;
			this.helpFrame.src = this.helpHref;
		}
	},
		
	_addAction: function(){
		if (this.actionLabel!='' && this.actionLabel!=null)
		{
			this.actionButton.onClick = this.actionFunction;
			this.actionButton.set("label",this.actionLabel);
		}
		else
			this.actionButton.domNode.style.display="none";
		
	},
	
	_toggle: function (event)
	{
		var link = event.currentTarget;
		var payload = this.attr(link.name);
	
		var classList = link.className.split(" ");
		var className = '';
		for (var c=0;c<classList.length;c++)
		{
			if (classList[c].indexOf("-open")>-1){
				classList[c] = classList[c].substring(0,classList[c].indexOf("-open"))+"-closed";
				className+=classList[c]+" ";
				payload.style.display="none";
				break;
			}
			else if (classList[c].indexOf("-closed")>-1){
				classList[c] = classList[c].substring(0,classList[c].indexOf("-closed"))+"-open";
				className+=classList[c]+" ";
				payload.style.display="block";
				break;
			}
			else
				className+=classList[c]+" ";
		}
		link.className = className;
		
	},
	
	addFunction: function(name,id,text)
	{
		this.inherited(arguments);
	
		this.actionButton.style.display="block";
		this.actionButton.onClick = window[name];
		this.actionButton.label=this.actionLabel;
	}
});